
import java.util.*;

public class LicenseNumberStamper  {

	/**
	 *  The lowest order stamping wheel. This one gets incremented
	 *  and the other follow appropriately.
	 */
	private StamperWheel lowOrderWheel_;
	public StamperWheel lowOrderWheel() { return lowOrderWheel_; }
	public void lowOrderWheel( StamperWheel aStamperWheel ) { lowOrderWheel_ = aStamperWheel; }

	/**
	 *  The inspector for this stamping machine.
	 */
	private StampingMachineInspector stampingMachineInspector_;
	public StampingMachineInspector stampingMachineInspector() { return stampingMachineInspector_; }
	public void stampingMachineInspector( StampingMachineInspector aStampingMachineInspector ) { stampingMachineInspector_ = aStampingMachineInspector; }
    
    public LicenseNumberStamper()  {
        this.initialize();
    }
    
    private void initialize() {
        this.setupWheelsForCalifornia();
        this.stampingMachineInspector(new StampingMachineInspector(this));
    }

    public void setupWheelsForCalifornia()  {
    
        StamperWheel aWheel = null;
        
        // set them up .. highest level first
        
        aWheel = new AlphabeticWheel(null); // has no superior wheel
        aWheel = new AlphabeticWheel(aWheel);
        aWheel = new AlphabeticWheel(aWheel);
        
        aWheel = new NumericWheel(aWheel);
        aWheel = new NumericWheel(aWheel);
        aWheel = new NumericWheel(aWheel);
        this.lowOrderWheel(aWheel);
    }
    
    public void stampNextPlate()  {
        this.lowOrderWheel().advancePosition();
    }
    
    public String currentPlateID()  {
        StringBuffer s = new StringBuffer();
        StamperWheel aWheel = this.lowOrderWheel();
        while (aWheel != null)  {
            s.append(aWheel);
            aWheel = aWheel.superiorWheel();
        }
        return s.reverse().toString();
    }
        
}